=== debian/changelog ===
calamares (3.2.0-1) unstable; urgency=medium

  * New upstream release
  * Add btrfs-progs to recommends
  * Update lintian-overrides

 -- Jonathan Carter <jcc@debian.org>  Fri, 18 May 2018 10:36:44 +0200
